]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame_incremental - rpm.macros
v1.720: add %fish_compdir
[packages/rpm-build-macros.git] / rpm.macros
... / ...
CommitLineData
1# vim:ts=4 sw=4 noet ft=spec
2#
3# PLD Linux rpm macros.
4# <http://www.pld-linux.org/>
5
6# can be used by builder script to check for version
7%rpm_build_macros {Revision}
8
9%epoch 0
10%x8664 x86_64 amd64 ia32e
11%arm armv3l armv4b armv4l armv5teb armv5tel
12
13# compiler version
14%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion 2>/dev/null || echo 0.0)}%cc_version
15%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion 2>/dev/null || echo 0.0)}%cxx_version
16
17%__rm /bin/rm --interactive=never
18
19# Build system path macros.
20%__autoconf autoconf %{?debug:-Wall}
21%__automake automake -a -c -f --foreign
22%__autopoint autopoint --force
23
24# add parallel build flags: -jN
25# jobs macro is available since 1.657
26#
27# if you want to disable parallel build do:
28# echo '%__jobs %{nil}' >> ~/.rpmmacros
29%__jobs %{expand:%%global __jobs %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); [ "$_NCPUS" -gt 3 ] && echo $(($_NCPUS / 2)))%%{nil}}%__jobs
30
31# expands to -jN if %__jobs has a value
32%_smp_mflags %{expand:%%global _smp_mflags %(jobs=%{__jobs}; echo ${jobs:+-j$jobs}%%{nil})}%_smp_mflags
33
34%__make /usr/bin/make %{?_make_opts} %{?_smp_mflags}
35%__scons /usr/bin/scons %{?_smp_mflags}
36%__waf /usr/bin/waf %{?_smp_mflags}
37%__cmake /usr/bin/cmake
38
39%__gettextize { \
40 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
41 gettextize --copy --force --no-changelog; \
42 else \
43 gettextize --copy --force --no-changelog --intl; \
44 fi; \
45 if [ ! -f po/Makevars ]; then \
46 cp -f po/Makevars{.template,}; \
47 fi; \
48}
49
50%__glib_gettextize glib-gettextize --copy --force
51%__gnome_doc_common gnome-doc-common --copy
52%__gnome_doc_prepare gnome-doc-prepare --copy --force
53%__gtkdocize gtkdocize --copy
54%__intltoolize intltoolize --copy --force
55%__libtoolize libtoolize --copy --force --install
56
57# topdir is where builder script lives,
58# fallback to old style if SPECS/SOURCES dirs were found.
59%_topdir %{expand:%%global _topdir %(
60 if [ -d SPECS -a -d SOURCES ]; then
61 # old style rpmdir: in topdir
62 pwd
63 elif [ -d ../SPECS -a -d ../SOURCES ]; then
64 # old style rpmdir: in subdir
65 cd ..; pwd
66 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
67 # if old style rpm dir exist, go with it
68 echo $HOME/rpm; \
69 elif [ -x ../builder -a ! -d ../builder ]; then
70 # relative new style rpmdir: in package dir
71 cd ..; pwd
72 elif [ -x builder -a ! -d builder ]; then
73 # relative new style rpmdir: in packages
74 pwd
75 elif [ -x packages/builder -a ! -d packages/builder ]; then
76 # relative new style rpmdir: packages dir in current dir
77 cd packages; pwd
78 else
79 # fallback to new style rpmdir
80 echo $HOME/rpm/packages
81 fi; \
82)}%_topdir
83
84# if %{_topdir}/SPECS exists, it's old style structure
85%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
86%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
87
88# BUILD/RPMS/SRPMS are on same level by default as packages dir, if these exist
89# if they don't exist assume we are having custom topdir (which is not named as
90# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
91# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therefore the extra echo
92%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
93%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
94%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
95
96# The number of cvs changelog entries kept when building package.
97%_buildchangelogtruncate 20
98
99%dependencytracking %{nil}
100
101# Relations between package names that cause dependency loops
102# with legacy packages that cannot be fixed. Relations are
103# specified as
104# p>q
105# where package p has a Requires: on something that package q Provides:
106#
107# XXX Note: that there cannot be any whitespace within the string "p>q",
108# and that both p and q are package names (i.e. no version/release).
109%_dependency_whiteout %{nil}
110
111#-----------------------------------------------------------------
112#
113# (re)definition of %{rpm*flags} with %filterout_* support
114# BuildRequires: awk
115# BuildRequires: rpmbuild(macros) >= 1.315
116#
117# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
118# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
119# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
120# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
121# %rpmldflags = %optldflags - %filterout_ld
122#
123# Regular expressions are supported, but to avoid some character be treated
124# as regular expression it must be escaped twice.
125
126%filter_out \
127 for (i = 1; i in I; i++) { A=0; \
128 for (f in F) { \
129 if (I[i] ~ "^" F[f] "$") A=1; \
130 }; \
131 if (!A) printf(I[i] FS); \
132 }
133
134%rpmcflags %(awk 'BEGIN {
135 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
136 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
137 %{filter_out}
138}')
139
140%rpmcxxflags %(awk 'BEGIN {
141 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
142 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
143 %{filter_out}
144}')
145
146%rpmcppflags %(awk 'BEGIN {
147 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
148 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
149 %{filter_out}
150}')
151
152%rpmldflags %(awk 'BEGIN {
153 split("%{?optldflags}",I);
154 split("%{?filterout_ld}",F)
155 %{filter_out}
156}')
157
158# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
159# but, don't use it, better use gcc as linker
160%ld_rpmldflags %(awk 'BEGIN {
161 split("%{rpmldflags}",F);
162 for (f in F) {
163 s = F[f];
164 if (s ~ /^-Wl,/) {
165 s = substr(s,5);
166 gsub(/,/," ",s);
167 };
168 printf(s FS);
169 };
170}')
171
172#-----------------------------------------------------------------
173#
174# Generate a command which cleans environment, leaving only the
175# most important variables.
176# If any spec requires any additional environment it should
177# redefine %_preserve_env in following manner:
178#
179# # ADDITIONAL_VAR is required because [a good reason here]
180# %define _preserve_env ADDITIONAL_VAR
181
182%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
183
184# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
185%_clean_env env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
186 split("%{?_preserve_env:%_preserve_env %_preserve_env_base}%{!?_preserve_env:%_preserve_env_base}", P);
187 for (i in P) {
188 p = P[i];
189 if (!ENVIRON[p] || d[p]) {
190 continue;
191 }
192 d[p] = 1;
193 split(ENVIRON[p], V, "");
194 val = p "=";
195 for (j = 1; j in V; j++) {
196 v = V[j];
197 if (v == q)
198 v = qq;
199 else if (v == "\\"")
200 v = q2q;
201 else if (v == "\\\\")
202 v = "\\\\\\\\";
203 else
204 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
205 val = val "" v;
206 }
207 printf(val " ");
208 }
209}')
210
211# override %__spec_build_pre and %__spec_install_pre from macros.rpmbuild
212# adding %{_clean_env}
213%__spec_build_pre %{_clean_env}\
214%{___build_pre}\
215%{nil}
216%__spec_install_pre %{_clean_env}\
217%{___build_pre}\
218%{?buildroot:%{__rm} -rf '%{buildroot}'; %{__mkdir_p} '%{buildroot}'}\
219%{nil}
220
221#-----------------------------------------------------------------
222%configure2_13 { \
223 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
224 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
225 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
226 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
227 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
228 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
229 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
230 %{?__cc:CC="%{__cc}" ; export CC ; } \
231 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
232 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
233 --host=%{_target_platform} \
234 --prefix=%{_prefix} \
235 --exec-prefix=%{_exec_prefix} \
236 --bindir=%{_bindir} \
237 --sbindir=%{_sbindir} \
238 --sysconfdir=%{_sysconfdir} \
239 --datadir=%{_datadir} \
240 --includedir=%{_includedir} \
241 --libdir=%{_libdir} \
242 --libexecdir=%{_libexecdir} \
243 --localstatedir=%{_localstatedir} \
244 --sharedstatedir=%{_sharedstatedir} \
245 --mandir=%{_mandir} \
246 --infodir=%{_infodir} \
247 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
248 %{dependencytracking} \
249}
250
251# Note: pass only standard cmake macros here.
252# The only exception is SYSCONF_INSTALL_DIR, used commonly in KDE packages,
253# where the default (${CMAKE_INSTALL_PREFIX}/etc) is not FHS-compliant and
254# absolute path MUST be used to comply with FHS.
255# The other non-standard cmake macros used commonly in KDE
256# (INCLUDE_INSTALL_DIR, LIB_INSTALL_DIR, SHARE_INSTALL_PREFIX)
257# have sane default values in KDE, and some packages use these names
258# in different way (e.g. expect them to be always relative or always
259# absolute).
260%cmake \
261%{?__cc:CC="${CC:-%{__cc}}"} \\\
262%{?__cxx:CXX="${CXX:-%{__cxx}}"} \\\
263CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \\\
264%{__cmake} \\\
265 -DCMAKE_VERBOSE_MAKEFILE=ON \\\
266 -DCMAKE_BUILD_TYPE=%{!?debug:PLD}%{?debug:Debug} \\\
267 -DCMAKE_INSTALL_BINDIR:PATH=%{_bindir} \\\
268 -DCMAKE_INSTALL_SBINDIR:PATH=%{_sbindir} \\\
269 -DCMAKE_INSTALL_LIBEXECDIR:PATH=%{_libexecdir} \\\
270 -DCMAKE_INSTALL_SYSCONFDIR:PATH=%{_sysconfdir} \\\
271 -DCMAKE_INSTALL_SHAREDSTATEDIRPATH:PATH=%{_sharedstatedir} \\\
272 -DCMAKE_INSTALL_LOCALSTATEDIRPATH:PATH=%{_localstatedir} \\\
273 -DCMAKE_INSTALL_LIBDIR:PATH=%{_libdir} \\\
274 -DCMAKE_INSTALL_INCLUDEDIR:PATH=%{_includedir} \\\
275 -DCMAKE_INSTALL_OLDINCLUDEDIR:PATH=%{_includedir} \\\
276 -DCMAKE_INSTALL_DATAROOTDIR:PATH=%{_datadir} \\\
277 -DCMAKE_INSTALL_DATADIR:PATH=%{_datadir} \\\
278 -DCMAKE_INSTALL_INFODIR:PATH=%{_infodir} \\\
279 -DCMAKE_INSTALL_LOCALEDIR:PATH=%{_localedir} \\\
280 -DCMAKE_INSTALL_MANDIR:PATH=%{_mandir} \\\
281 -DCMAKE_INSTALL_DOCDIR:PATH=%{_docdir} \\\
282 -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \\\
283 -DSYSCONF_INSTALL_DIR:PATH=%{_sysconfdir} \\\
284 -DCMAKE_CXX_FLAGS_PLD="${CXXFLAGS:-%{rpmcxxflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
285 -DCMAKE_C_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
286 -DCMAKE_Fortran_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG -DQT_NO_DEBUG}" \\\
287 -DCMAKE_EXE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
288 -DCMAKE_SHARED_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
289 -DCMAKE_MODULE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
290%if "%{_lib}" == "lib64" \
291 -DLIB_SUFFIX=64 \\\
292%endif \
293%if "%{_lib}" == "libx32" \
294 -DLIB_SUFFIX=x32 \\\
295%endif \
296 -DBUILD_SHARED_LIBS:BOOL=ON \\\
297%{nil}
298
299%scons { \
300%{__scons} \
301 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
302 CFLAGS="${CFLAGS:-%rpmcflags}" \
303 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
304 FFLAGS="${FFLAGS:-%rpmcflags}" \
305 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
306 %{?__cc:CC="%{__cc}"} \
307 %{?__cxx:CXX="%{__cxx}"} \
308 libsuffix=%{_lib} \
309 prefix=%{_prefix} \
310}
311
312# waf. see waf.spec
313%waf { \
314CC="%{__cc}" \
315CXX="%{__cxx}" \
316CPP="%{__cpp}" \
317CFLAGS="%{rpmcflags}" \
318CXXFLAGS="%{rpmcxxflags}" \
319LINKFLAGS="%{rpmldflags}" \
320%{__waf} \
321}
322
323#----------------------------------------------------------------
324#%configure_cache 0
325%configure_cache_file %{buildroot}.configure.cache
326
327%configure {./configure \
328 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
329 CFLAGS="${CFLAGS:-%rpmcflags}" \
330 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
331 FFLAGS="${FFLAGS:-%rpmcflags}" \
332 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
333 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
334 %{?__cc:CC="%{__cc}"} \
335 %{?__cxx:CXX="%{__cxx}"} \
336 --host=%{_target_platform} \
337 --build=%{_target_platform} \
338 --prefix=%{_prefix} \
339 --exec-prefix=%{_exec_prefix} \
340 --bindir=%{_bindir} \
341 --sbindir=%{_sbindir} \
342 --sysconfdir=%{_sysconfdir} \
343 --datadir=%{_datadir} \
344 --includedir=%{_includedir} \
345 --libdir=%{_libdir} \
346 --libexecdir=%{_libexecdir} \
347 --localstatedir=%{_localstatedir} \
348 --sharedstatedir=%{_sharedstatedir} \
349 --mandir=%{_mandir} \
350 --infodir=%{_infodir} \
351 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
352 %{dependencytracking} \
353 %{?configure_cache:--cache-file=%{configure_cache_file}} \
354}
355
356# Simple macros to simplify adding bconded options to configure scripts.
357# Each macro requires bcond name and accepts optional option name, if option
358# isn't specified bcond name is used as option name. Options returning
359# --with and --enable also allow third argument which will be added as value
360# ( --with-option=value or --enable-option=value ) in case or positive
361# condition, but won't be added otherwise ( nothing or just --disable-option ).
362
363# Requirements:
364# BuildRequires: rpmbuild(macros) >= 1.527
365
366# Usage example:
367# %{__enable bcond} - returns --enable-bcond iff build condition is set
368# %{__disable bcond option} - returns --enable-option iff bcond is not set
369# %{__enable_disable bcond option value} - returns --enable-option=value if
370# bcond is set, returns --disable-option otherwise
371
372# expand bconds to --enable-something and --disable-something
373%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
374%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
375%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
376
377# same as above, but condition inverted
378%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
379%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
380%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
381
382# expand bconds to --with-something and --without-something
383%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
384%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
385%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
386
387# same as above, but condition inverted
388%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
389%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
390%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
391
392#-----------------------------------------------------------------
393
394# overload to insert debuginfo package
395%prep \
396%if 0%{?_enable_debug_packages}\
397%{debug_package}\
398%endif\
399%%prep\
400%{nil}
401
402# Location of autoconf macros
403%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
404
405# Location of omf files
406%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
407
408# Location of pkgconfig files
409%_pkgconfigdir /usr/%{_lib}/pkgconfig
410# noarch pkgconfig files
411%_npkgconfigdir /usr/share/pkgconfig
412
413# Location of desktop files
414%_desktopdir /usr/share/applications
415%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
416
417# Location of pixmaps for applnk/desktop files
418%_pixmapsdir /usr/share/pixmaps
419
420# Location of themable icons for applnk/desktop files
421%_iconsdir /usr/share/icons
422
423# Location of fonts directories
424%_fontsdir /usr/share/fonts
425
426# Location of Gtk and associated libraries documentation
427%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
428
429# Location of KDE documentation
430%_kdedocdir %{_defaultdocdir}/kde/HTML
431
432# unsermake script
433%__unsermake /usr/share/unsermake/unsermake
434
435# Current date
436%date %(LC_ALL=C date +"%a %b %d %Y")
437
438# Example files, programs, scripts...
439%_examplesdir /usr/src/examples
440
441# SysV-style initscripts dir
442%_initddir /etc/rc.d/init.d
443
444# If non-empty "debug" macro defined, add "dbg" suffix to release number
445%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
446
447# Bootstrap release macros.
448# Usage:
449# %bcond_with bootstrap
450# Release: %{bootstrap_release 1}
451#
452# Package will have release 1 if built normally,
453# and release 0.zzz.bootstrap if built with bootstrap
454%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
455
456# Requires name = version-release
457%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
458# Requires: name = version
459%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
460# Requires: name = version (version based on querying package %2)
461%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
462
463# Requires: name >= version
464%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
465# Requires: name >= version (version based on querying package %2)
466%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
467
468# helper for renaming packages
469# %rename old-package
470%rename() \
471Obsoletes: %{1} < %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}} \
472Provides: %{1} = %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}}
473
474%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
475
476# sgml macros
477%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
478%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
479%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
480%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
481%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
482%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
483%docbook_sgmlcat_fix() { for l in \
484'' \
485' -- default decl --' \
486'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
487' -- hacks for opensp --' \
488'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
489'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
490'' \
491; do echo $l; done >> %1 \
492}
493
494# vim - "
495
496# minimum file size needed for compressed documents.
497# just smaller files than this get larger when compressed.
498# some stats:
499# - 0 byte file compressed was 25 bytes .gz
500# - 39 byte file was compressed as 57
501# - with test/test.spec@man 158 byte file was compressed also 158
502%_min_compress_bytes 159
503
504#-----------------------------------------------------------------
505# find and gzip all files in %{_mandir} and %{infodir}
506#
507# Requires: xargs, find
508#
509#%no_install_post_compress_docs 1
510%__spec_install_post_compress_docs { \
511%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
512 %{!?debug:set +x;} \
513 for i in /usr/share/man /usr/X11R6/man; do \
514 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
515 echo "Compress man pages: $i"; \
516 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
517 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
518 find $RPM_BUILD_ROOT$i -type l | while read a; do \
519 m=$(readlink "$a"); \
520 if [[ "$m" = */* ]]; then \
521 # handle links to different man section \
522 l=$(readlink -f "$a"); \
523 # full/relative paths that resolve symlink \
524 l=${l#$RPM_BUILD_ROOT/usr/share/man/}; \
525 l=${l#$RPM_BUILD_ROOT/usr/X11R6/man/}; \
526 # full paths that do not resolve symlink \
527 l=${l#/usr/share/man/}; \
528 l=${l#/usr/X11R6/man/}; \
529 else \
530 l=${a#$RPM_BUILD_ROOT$i/}; \
531 l=${l%/*}; \
532 l="$l/$m"; \
533 fi; \
534 rm -f $a; \
535 echo ".so $l" > $a; \
536 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: $l"; \
537 done; \
538 # verify that .so links point to existing files (not allowed to point to "other package") \
539 # TODO: iterate over all man dirs, but in Th there is only one true man dir \
540 err=$(grep -rl '^\.so ' "$RPM_BUILD_ROOT$i" | while read doc; do \
541 l=$(grep -r '^\.so ' "$doc"); \
542 l=${l#.so }; \
543 d=$(dirname $doc); \
544 test -e $RPM_BUILD_ROOT$i/$l || test -e $d/$(basename $l) || echo " ${doc#$RPM_BUILD_ROOT} points to inexistent manpage: $l"; \
545 done); \
546 test "$err" != "" && { echo >&2 "Man page link errors:"; echo >&2 "$err"; exit 1; }; \
547 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
548 fi; \
549 done; \
550 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
551 echo "Compress info pages: %{_infodir}"; \
552 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
553 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
554 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
555 fi; \
556}; __spec_install_post_compress_docs } }
557
558#-----------------------------------------------------------------
559# Strip executable binaries and shared object files
560#
561# Requires: find, awk, strip, cut, xargs
562#
563# Special macros which affect this process:
564#%no_install_post_strip 1 # disable stripping at all
565#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
566#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
567#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
568#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
569#
570%__spec_install_post_strip {%{!?debug: \
571%{!?no_install_post_strip:__spec_install_post_strip() { \
572%{!?debug:set +x;} \
573if [ -d "$RPM_BUILD_ROOT" ]; then \
574 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
575 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
576 if [ "$modulelist" ]; then \
577 modulecount=$(echo "$modulelist" | wc -l); \
578 printf "Stripping %d kernel modules..." $modulecount; \
579 echo "$modulelist" | xargs -l512 chmod u+w; \
580 echo "$modulelist" | xargs -l512 %{__strip} -g --remove-section=.comment --remove-section=.note.GNU-stack; \
581 echo "DONE"; \
582 fi; \
583 fi; \
584 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
585 if [ -n "$filelist" ]; then \
586 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
587 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
588 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
589 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
590 if [ -n "$elfexelist" ]; then \
591 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
592 echo "$elfexelist" | xargs -r -d'\n' chmod u+w; \
593 echo "$elfexelist" | xargs -r -d'\n' %{__strip} --remove-section=.note --remove-section=.comment; \
594 echo "DONE"; \
595 fi; \
596 if [ -n "$elfsharedlist" ]; then \
597 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
598 echo "$elfsharedlist" | xargs -r -d'\n' chmod u+w; \
599 echo "$elfsharedlist" | xargs -r -d'\n' %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment; \
600 echo "DONE"; \
601 fi; \
602 if [ -n "$archiveslist" ]; then \
603 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
604 echo "$archiveslist" | xargs -r -d'\n' chmod u+w; \
605 echo "$archiveslist" | xargs -r -d'\n' %{__strip} --strip-debug --remove-section=.note --remove-section=.comment; \
606 echo "DONE"; \
607 fi; \
608 fi; \
609 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
610 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
611 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
612 if [ -n "$filelist_all" ]; then \
613 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
614 chmod u+w $filelist_all; \
615 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
616 echo "DONE"; \
617 fi; \
618 if [ -n "$filelist_unneeded" ]; then \
619 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
620 chmod u+w $filelist_unneeded; \
621 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
622 echo "DONE"; \
623 fi; \
624 if [ -n "$filelist_debug" ]; then \
625 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
626 chmod u+w $filelist_debug; \
627 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
628 echo "DONE"; \
629 fi; \
630fi; }; __spec_install_post_strip } } }
631
632#-----------------------------------------------------------------
633# remove all RPATH/RUNPATH from executable binaries and shared object files
634#
635# Requires: find, awk, cut, xargs, chrpath, uname
636#
637# Special macros which affect this process
638#%no_install_post_chrpath 1 # disable chrpath at all
639#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
640#
641%__spec_install_post_chrpath {%{!?debug: \
642%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
643%{!?debug:set +x;} \
644if [ -d "$RPM_BUILD_ROOT" ]; then \
645 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
646 if [ -n "$files" ]; then \
647 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
648 fi; \
649 if [ -n "$objs" ]; then \
650 printf "Remove RPATH/RUNPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
651 echo "$objs" | \
652 while read file; do \
653 rpath= ; \
654 chmod u+w "$file"; \
655 for dir in $(chrpath -l "$file" | awk '/(R|RUN)PATH=/ { gsub(/.*RPATH=/,""); gsub(/.*RUNPATH=/,""); gsub(/:/," "); print $0 }'); do \
656 case $dir in \
657 '$ORIGIN' ) \
658 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
659 else rpath="$rpath:$dir" ; fi ; \
660 continue ; \
661 ;; \
662 esac ; \
663 newdir=$(readlink -m "$dir"); \
664 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
665 case $dir in \
666 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
667 echo "remove-rpath: $dir in $file"; \
668 ;; \
669 * ) \
670 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
671 else rpath="$rpath:$dir" ; fi ; \
672 ;; \
673 esac ; \
674 done ; \
675 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
676 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
677 done; \
678 fi; \
679fi; }; __spec_install_post_chrpath } } }
680
681# vim: "
682
683#-----------------------------------------------------------------
684# Find all shared object files with unresolved symbols. Warn
685# and terminate if any found (termination can be turned off by define).
686#%no_install_post_check_so 1
687#%skip_post_check_so libwithunresolvedok.so.*
688#
689# NOTE: define skip_post_check_so only if such library really requires
690# unresolved symbols and always leave a comment why it is required:
691# # executable provides symbols foo, bar for those libraries:
692# %define skip_post_check_so libwithoutfoo.so.* libwithoutbar.so.*
693#
694%__spec_install_post_check_so { \
695__spec_install_post_check_so() { \
696%{!?debug:set +x;} \
697 fail=0; \
698 printf "Searching for shared objects with unresolved symbols..."; \
699 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
700 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; %{?skip_post_check_so:split("%{skip_post_check_so}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "Library marked with skip_post_check_so, ignoring errors.\n"; exit(0); } } } exit(1); } } ' || fail=1 ; \
701 done ; \
702 echo " DONE"; \
703 %{!?no_install_post_check_so:return $fail;} \
704}; __spec_install_post_check_so }}
705
706#-----------------------------------------------------------------
707# Verify that for each directory under /var/run package contains
708# tmpfiles.d configuration. Warn and terminate build if config is
709# missing.
710#
711#%no_install_post_check_tmpfiles 1
712#
713%__spec_install_post_check_tmpfiles { \
714__spec_install_post_check_tmpfiles() { \
715%{!?debug:set +x;} \
716 fail=0; \
717 echo "Checking /var/run <-> tmpfiles.d completeness..."; \
718 for d in $RPM_BUILD_ROOT/var/run/*; do \
719 [ -d "$d" ] || continue; \
720 d=${d##$RPM_BUILD_ROOT}; \
721 if ! grep -qsF "$d" $RPM_BUILD_ROOT/usr/lib/tmpfiles.d/*.conf $RPM_BUILD_ROOT/etc/tmpfiles.d/*.conf; then\
722 echo "No tmpfiles configuration for '$d'";\
723 fail=1 ; \
724 fi \
725 done ; \
726 echo " DONE"; \
727 %{!?no_install_post_check_tmpfiles:return $fail;} \
728}; __spec_install_post_check_tmpfiles }}
729
730#-----------------------------------------------------------------
731# Verify that scripts have reasonable shebangs
732# Test spec: see "test/spec_install_post_check_shebangs" branch on packages/test.spec
733#
734#%no_install_post_check_shebangs 1
735#
736%__spec_install_post_check_shebangs { \
737__spec_install_post_check_shebangs() { \
738%{!?debug:set +x;} \
739 fail=0; \
740 echo "Checking script shebangs..."; \
741 find $RPM_BUILD_ROOT -type f -perm -500 -print | \
742 while read f ; do \
743 shebang="$(sed -e'1s/#! *\(.*\)/\1/;t;d;q' "$f")" ; \
744 f="${f##$RPM_BUILD_ROOT}"; \
745 case "$shebang" in \
746 "%{__python}"|"%{__python3}"|"%{__python} "*|"%{__python3} "* \
747 |"/usr/bin/python%{py_ver}"|"/usr/bin/python%{py_ver} "* \
748 |"/usr/bin/python%{py3_ver}"|"/usr/bin/python%{py3_ver} "*) \
749 ;; \
750 "/usr/bin/env python"*|"/usr/bin/python"|"/usr/bin/python "*) \
751 echo "$f starts with '#!$shebang', should be '#!%{__python}' or '#!%{__python3}'" >&2;\
752 fail=1 ; \
753 ;; \
754 "/usr/bin/env "*) \
755 echo "$f starts with '#!$shebang', should be explicit interpreter path" >&2;\
756 fail=1 ; \
757 ;; \
758 *) ;;\
759 esac ; \
760 done ; \
761 echo " DONE" ; \
762}; %{!?no_install_post_check_shebangs:__spec_install_post_check_shebangs} }
763
764# Remove common Perl files we don't package
765%__spec_install_post_perl_clean {\
766%{!?no_install_post_perl_clean: \
767%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
768} }
769
770#-----------------------------------------------------------------
771# Update GConf2 schemas
772#
773# Requires: GConf2
774#
775%gconf_schema_install() \
776 umask 022; \
777 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
778 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
779%{nil}
780
781%gconf_schema_uninstall() \
782if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
783 umask 022; \
784 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
785 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
786fi; \
787%{nil}
788
789#-----------------------------------------------------------------
790# Update desktop MIME database
791# requires: desktop-file-utils
792%update_desktop_database() {{ \
793 umask 022; \
794 /usr/bin/update-desktop-database -q; \
795};} \
796%{nil}
797
798%update_desktop_database_post %update_desktop_database
799
800%update_desktop_database_postun() {{ \
801if [ "$1" = "0" ]; then \
802 %update_desktop_database \
803fi; \
804};} \
805%{nil}
806
807#-----------------------------------------------------------------
808# Update shared MIME info database
809# requires: shared-mime-info
810#
811%update_mime_database() {{ \
812 umask 022; \
813 /usr/bin/update-mime-database %{_datadir}/mime; \
814};} \
815%{nil}
816
817#-----------------------------------------------------------------
818# Update icon cache
819# BuildRequires: rpmbuild(macros) >= 1.596
820# Requires: hicolor-icon-theme
821#
822%update_icon_cache() {{ \
823 %{!?1:%{error:%{0}: Required theme name missing}} \
824 if [ -x /usr/bin/gtk-update-icon-cache ]; then \
825 umask 022; \
826 touch --no-create %{_iconsdir}/%1; \
827 /usr/bin/gtk-update-icon-cache -qf %{_iconsdir}/%1; \
828 fi; \
829};} \
830%{nil}
831
832#-----------------------------------------------------------------
833# Update scrollkeeper database
834# requires: scrollkeeper
835#
836%scrollkeeper_update_post() \
837 /usr/bin/scrollkeeper-update -q; \
838%{nil}
839
840%scrollkeeper_update_postun() \
841if [ "$1" = "0" ]; then \
842 /usr/bin/scrollkeeper-update -q; \
843fi; \
844%{nil}
845
846#-----------------------------------------------------------------
847# Compile GSettings schemas
848# requires: glib2 >= 1:2.26.0
849#
850%glib_compile_schemas() {{ \
851 umask 022; \
852 /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas; \
853};} \
854%{nil}
855
856#-----------------------------------------------------------------
857# post %install sequence:
858# - autodeps exceptions
859# - compress all man and info pages,
860# - strip all ELF executables and ELF shared objects if not %debug.
861# - compress kernel modules if any
862
863###################################################################
864# Requires/Provides automation
865# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
866#
867%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
868%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
869%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
870%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
871%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq) \
872 %{?_noautoreq: %{_noautoreq}} \
873 %{?_noautoreq_pear: %{__noauto_regexp_helper -p pear %{_noautoreq_pear}}} \
874 %{?_noautoreq_perl: %{__noauto_regexp_helper -p perl %{_noautoreq_perl}}} \
875 %{?_noautoreq_java: %{__noauto_regexp_helper -p java %{_noautoreq_java}}} \
876 %{?_noautoreq_pyegg: %{__noauto_regexp_helper -p pythonegg %{_noautoreq_pyegg}}} \
877 %{?_noautoreq_py3egg: %{__noauto_regexp_helper -p python3egg %{_noautoreq_py3egg}}} \
878 %{nil}
879
880# helper for wrapping _noautoreq between perl() or pear()
881# Author: Elan Ruusamäe <glen@pld-linux.org>
882# Usage:
883# BuildRequires: rpmbuild(macros) >= 1.654
884# %define _noautoreq_pear Excluded.php PEAR/Something.php
885# %define _noautoreq_perl Apache::.*
886# BuildRequires: rpmbuild(macros) >= 1.672
887# %define _noautoreq_java ClassDataVersion
888#
889%__noauto_regexp_helper(p:) %(echo "%*" | awk 'BEGIN{RS=" "}{printf("%{-p*}%{__qchar}(%%s%{__qchar}) ", $1)}')
890# detect quote character runtime
891%__qchar_4 \\\\%{nil}
892%__qchar_5 \\\\\\%{nil}
893%__qchar %{expand:%%global __qchar %%__qchar_%(echo %{_rpmversion} | cut -c1)}%__qchar
894
895#%_noautocompressdoc %{nil}
896#
897%_missing_doc_files_terminate_build 1%{nil}
898%_unpackaged_files_terminate_build %{nil}
899# (X)emacs support
900%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
901%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
902%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
903
904%__php_provides %{nil}
905%__php_requires %{nil}
906%__perl_provides %{nil}
907%__perl_requires %{nil}
908%__mono_provides %{nil}
909%__mono_requires %{nil}
910
911# Perl specific macro definitions.
912%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
913%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
914%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
915%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
916%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
917%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
918
919# Ruby
920%__ruby /usr/bin/ruby
921
922# Ruby ABI version
923# NOTE: %ruby_version may be empty, depending how Ruby was built
924%ruby_abi %{expand:%%global ruby_abi %(%{__ruby} -r rbconfig -e 'print [RbConfig::CONFIG["MAJOR"], RbConfig::CONFIG["MINOR"]].join(".")' 2>/dev/null || echo ERROR)}%ruby_abi
925
926# get rbconfig parameter
927%__ruby_rbconfig() %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["%1"]' 2>/dev/null || echo ERROR)
928%__ruby_rbconfig_path() %(%{__ruby} -r rbconfig -r pathname -e 'print Pathname(RbConfig::CONFIG["%1"]).cleanpath' 2>/dev/null || echo ERROR)
929
930%ruby_archdir %{expand:%%global ruby_archdir %{__ruby_rbconfig_path archdir}}%ruby_archdir
931%ruby_libdir %{expand:%%global ruby_libdir %{__ruby_rbconfig rubylibdir}}%ruby_libdir
932%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'print File.join(RbConfig::CONFIG["datadir"], "ri", RbConfig::CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
933%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %{__ruby_rbconfig_path rubylibdir}}%ruby_rubylibdir
934%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %{__ruby_rbconfig vendorarchdir}}%ruby_vendorarchdir
935%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %{__ruby_rbconfig_path vendorlibdir}}%ruby_vendorlibdir
936%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %{__ruby_rbconfig sitearchdir}}%ruby_sitearchdir
937%ruby_sitedir %{expand:%%global ruby_sitedir %{__ruby_rbconfig sitedir}}%ruby_sitedir
938%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %{__ruby_rbconfig_path sitelibdir}}%ruby_sitelibdir
939%ruby_rdocdir /usr/share/rdoc
940%ruby_vendordir %{expand:%%global ruby_vendordir %{__ruby_rbconfig vendordir}}%ruby_vendordir
941%ruby_version %{expand:%%global ruby_version %(r=%{__ruby_rbconfig ruby_version}; echo ${r:-%%nil})}%ruby_version
942
943%ruby_gemdir %{expand:%%global ruby_gemdir %(%{__ruby} -r rubygems -e 'puts Gem.respond_to?(:default_dirs) ? Gem.default_dirs[:system][:gem_dir] : Gem.path.first' 2>/dev/null || echo ERROR)}%{ruby_gemdir}
944%ruby_specdir %{ruby_gemdir}/specifications
945
946# deprecated, ruby 2.0 noarch packages are versionless and extension dependency is generated by rpm5
947%ruby_ver_requires_eq %{nil}
948%ruby_mod_ver_requires_eq %{nil}
949
950%php_pear_dir /usr/share/pear
951%php_data_dir /usr/share/php
952%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
953%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
954%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
955
956# extract php/zend api versions
957%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
958%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
959%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
960%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
961%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
962%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
963%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
964%_zend_zts %{expand:%%global _zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%_zend_zts
965# "_ts" if ZTS enabled, empty otherwise
966%zend_zts %{expand:%%global _zend_zts_%{?_zend_zts} 1}%{?_zend_zts_1:_ts}
967
968# name of php package
969%php_name php%{?php_suffix}
970# use rpmbuild -D 'php_suffix 54' to build php extension for php 5.4
971# NOTE: error output must be empty. otherwise can't build pecl packages if no php*-devel is installed
972%php_suffix %{expand:%%global php_suffix %(c=$(php-config --sysconfdir 2>/dev/null) || echo '' && echo ${c#/etc/php})%%{nil}}%php_suffix
973
974# phpXY, version always present for using current php version (in regards of php*-devel package)
975%php_versuffix %{expand:%%global php_versuffix %((IFS=.; set -- $(php-config --version); echo $1$2))%%{nil}}%php_versuffix
976
977# php cli. version that php headers are installed for
978%__php /usr/bin/php%{php_versuffix}
979
980# helper macro
981%__php_api_requires() Requires: %{php_name}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
982
983# macros for public use
984# for php extensions (php-pecl)
985%requires_php_extension %{__php_api_requires modules_api php_api_version} \
986%{__php_api_requires zend_module_api} \
987%{__php_api_requires debug php_debug} \
988%{__php_api_requires thread-safety _zend_zts}
989
990# for zend extensions
991%requires_zend_extension %{__php_api_requires zend_module_api} \
992%{__php_api_requires zend_extension_api} \
993%{__php_api_requires debug php_debug} \
994%{__php_api_requires thread-safety _zend_zts}
995
996# for php pdo modules (php-pecl-PDO_*)
997%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
998
999# for using PHP post scripts. for PHP >= 5.0
1000%php_webserver_restart \
1001[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
1002[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
1003if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
1004 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
1005 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
1006 %service -q php-fcgi restart \
1007 fi \
1008fi \
1009if [ -x /etc/rc.d/init.d/%{php_name}-fpm ]; then \
1010 %service -q %{php_name}-fpm restart \
1011fi \
1012%{nil}
1013
1014# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
1015%php4_webserver_restart \
1016[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
1017[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
1018if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
1019 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
1020 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
1021 %service -q php-fcgi restart \
1022 fi \
1023fi \
1024%{nil}
1025
1026# X.org helper macros
1027%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
1028%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
1029
1030%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
1031%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
1032%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
1033%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
1034%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
1035# vim: '
1036
1037%requires_xorg_xserver_extension \
1038%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1039%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1040%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
1041%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
1042%{nil}
1043
1044%requires_xorg_xserver_xinput \
1045%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1046%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1047%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
1048%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
1049%{nil}
1050
1051%requires_xorg_xserver_font \
1052%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1053%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1054%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
1055%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
1056%{nil}
1057
1058%requires_xorg_xserver_videodrv \
1059%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1060%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1061%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
1062%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
1063%{nil}
1064
1065# TCL specific macro definitions.
1066# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
1067%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
1068%tcl_sitearch %{_libdir}/tcl%{tcl_version}
1069%tcl_sitelib %{_datadir}/tcl%{tcl_version}
1070
1071# Python specific macro definitions.
1072# python main version
1073%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
1074
1075# directories
1076%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
1077%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
1078%py_scriptdir %{py_prefix}/share/python%{py_ver}
1079%py_incdir /usr/include/python%{py_ver}
1080%py_sitedir %{py_libdir}/site-packages
1081%py_sitescriptdir %{py_scriptdir}/site-packages
1082%py_dyndir %{py_libdir}/lib-dynload
1083
1084# pure python modules compilation
1085%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1086
1087%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1088
1089# Software written in Python language require Python with main version
1090%pyrequires_eq() Requires: %1
1091
1092# Python 3.x
1093# python main version
1094%__python3 /usr/bin/python3
1095%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
1096
1097# directories
1098%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
1099%py3_incdir %{expand:%%global py3_incdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('include'))" 2>/dev/null || echo ERROR)}%py3_incdir
1100%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
1101%py3_sitedir %{py3_libdir}/site-packages
1102%py3_sitescriptdir %{py3_prefix}/share/python%{py3_ver}/site-packages
1103%py3_dyndir %{py3_libdir}/lib-dynload
1104
1105# pure python modules compilation
1106%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1107
1108%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1109
1110%py_build { \
1111 LDFLAGS="${LDFLAGS:-%rpmldflags}"; export LDFLAGS; \
1112 CFLAGS="${CFLAGS:-%rpmcppflags %rpmcflags}"; export CFLAGS; \
1113 CXXFLAGS="${CXXFLAGS:-%rpmcppflags %rpmcxxflags}"; export CXXFLAGS; \
1114 %{?__cc:CC="%{__cc}"; export CC;} \
1115 %{?__cxx:CXX="%{__cxx}"; export CXX;} \
1116 %{__python} setup.py \
1117 build --build-base=build-2 \
1118}
1119
1120# "shrink" filter to keep this macro without newlines,
1121# so it could be used as make arguments
1122%py_install_opts() %{shrink: \
1123 --prefix=%{_prefix} \
1124 --install-purelib=%{py_sitescriptdir} \
1125 --install-platlib=%{py_sitedir} \
1126 --optimize=2 \
1127}
1128
1129%py_install { \
1130 LDFLAGS="${LDFLAGS:-%rpmldflags}"; export LDFLAGS; \
1131 CFLAGS="${CFLAGS:-%rpmcppflags %rpmcflags}"; export CFLAGS; \
1132 CXXFLAGS="${CXXFLAGS:-%rpmcppflags %rpmcxxflags}"; export CXXFLAGS; \
1133 %{?__cc:CC="%{__cc}"; export CC;} \
1134 %{?__cxx:CXX="%{__cxx}"; export CXX;} \
1135 %{__python} setup.py \
1136 build --build-base=build-2 \
1137 install --skip-build \
1138 %{py_install_opts} \
1139 --root=$RPM_BUILD_ROOT \
1140}
1141
1142%py3_build { \
1143 LDFLAGS="${LDFLAGS:-%rpmldflags}"; export LDFLAGS; \
1144 CFLAGS="${CFLAGS:-%rpmcppflags %rpmcflags}"; export CFLAGS; \
1145 CXXFLAGS="${CXXFLAGS:-%rpmcppflags %rpmcxxflags}"; export CXXFLAGS; \
1146 %{?__cc:CC="%{__cc}"; export CC;} \
1147 %{?__cxx:CXX="%{__cxx}"; export CXX;} \
1148 %{__python3} setup.py build --build-base=build-3 \
1149}
1150
1151# "shrink" filter to keep this macro without newlines,
1152# so it could be used as make arguments
1153%py3_install_opts() %{shrink: \
1154 --prefix=%{_prefix} \
1155 --install-purelib=%{py3_sitescriptdir} \
1156 --install-platlib=%{py3_sitedir} \
1157 --optimize=2 \
1158}
1159
1160%py3_install { \
1161 LDFLAGS="${LDFLAGS:-%rpmldflags}"; export LDFLAGS; \
1162 CFLAGS="${CFLAGS:-%rpmcppflags %rpmcflags}"; export CFLAGS; \
1163 CXXFLAGS="${CXXFLAGS:-%rpmcppflags %rpmcxxflags}"; export CXXFLAGS; \
1164 %{?__cc:CC="%{__cc}"; export CC;} \
1165 %{?__cxx:CXX="%{__cxx}"; export CXX;} \
1166 %{__python3} setup.py \
1167 build --build-base=build-3 \
1168 install --skip-build \
1169 %{py3_install_opts} \
1170 --root=$RPM_BUILD_ROOT \
1171}
1172
1173# node.js libdir
1174# Requirements:
1175# BuildRequires: rpmbuild(macros) >= 1.634
1176%nodejs_libdir /usr/lib/node_modules
1177
1178# bash-completion 2.0 completions dir
1179# Requirements:
1180# BuildRequires: rpmbuild(macros) >= 1.673
1181# Requires: bash-completion >= 2.0
1182%bash_compdir /usr/share/bash-completion/completions
1183
1184# fish completions dir
1185# Requirements:
1186# BuildRequires: rpmbuild(macros) >= 1.720
1187%fish_compdir /usr/share/fish/vendor_completions.d
1188
1189# zsh completions dir
1190# Requirements:
1191# BuildRequires: rpmbuild(macros) >= 1.719
1192%zsh_compdir /usr/share/zsh/site-functions
1193
1194# Hardlink binary identical .pyc and .pyo files
1195%__spec_install_post_py_hardlink {\
1196%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
1197%{!?debug:set +x;} \
1198local a b c=0 t=0 pyc=%{tmpdir}/%{name}-%{version}-%{release}__rpm_pyc; \
1199if [ -d "$RPM_BUILD_ROOT" ]; then \
1200 find "$RPM_BUILD_ROOT" -name '*.pyc' > $pyc; \
1201 while read a; do \
1202 b="${a%.pyc}.pyo"; \
1203 if cmp -s "$a" "$b"; then \
1204 ln -f "$a" "$b"; \
1205 c=$((c + 1)); \
1206 fi; \
1207 t=$((t + 1)); \
1208 done < $pyc; \
1209 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
1210 rm -f $pyc; \
1211fi; \
1212}; __spec_install_post_py_hardlink } }
1213
1214# Remove Python 2.x sources,
1215# PLD Linux policy is to package only compiled .py[co] for Python 2.x libraries.
1216# Author: Elan Ruusamäe <glen@pld-linux.org>
1217#
1218# Usage:
1219# %py_postclean /usr/share/extra -x keepme.py,keeptoo.py
1220# Options:
1221# -x - comma separated of file basenames to preserve (rpmbuild(macros) >= 1.658)
1222# ARGS - extra directories to clean for .py sources
1223#
1224# BuildRequires: rpmbuild(macros) >= 1.189
1225#
1226%py_postclean(x:) \
1227for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
1228 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 %{-x:| grep -ZzvE '/(%(echo '%{-x*}' | tr ',' '|'))$'} | xargs -0r -l512 rm;\
1229done \
1230%{nil}
1231
1232# depmod macro
1233%depmod() { \
1234umask 022; \
1235if [ -e /boot/System.map-%1 ]; then \
1236 /sbin/depmod -a -F /boot/System.map-%1 %1; \
1237else \
1238 if [ -e /boot/System.map ]; then \
1239 /sbin/depmod -a -F /boot/System.map %1; \
1240 else \
1241 /sbin/depmod -a %1; \
1242 fi \
1243fi; \
1244}
1245
1246# XMMS specific macros
1247%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
1248%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
1249%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
1250%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
1251%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
1252%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
1253%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1254%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1255%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1256%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1257
1258# user/group checking macros
1259#
1260# Usage:
1261# %userremove myuser
1262#
1263%userremove /usr/lib/rpm/user_group.sh user del
1264%groupremove /usr/lib/rpm/user_group.sh group del
1265#
1266# Usage:
1267# if %usertestrm myuser; then
1268# /usr/sbin/userdel -r myuser
1269# Note:
1270# use these macros only if you need to call userdel/groupdel with
1271# a non-standard option or take an extra action; otherwise use the
1272# %userremove/%groupremove macros
1273#
1274%usertestrm /usr/lib/rpm/user_group.sh user testrm
1275%grouptestrm /usr/lib/rpm/user_group.sh group testrm
1276# user group membership management macros
1277#
1278# Usage:
1279# %addusertogroup [-q] myuser agroup
1280#
1281# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1282#
1283# Requirements:
1284# BuildRequires: rpmbuild(macros) >= 1.515
1285%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1286%{nil}
1287
1288# banner support (useful in {pre,post}{,un} and triggers)
1289#
1290# Usage:
1291# %banner name [-a] [-e] [-n] [-tn] [-o] <<EOF
1292# the banner text, the banner text
1293# the banner text, and following line
1294#EOF
1295# You can use any form of here-document, <<'EOF' <<-EOT will do.
1296# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1297#
1298# -a - append to the banner
1299# -e - send to stderr instead of stdout
1300# -n - don't show banner (overrides -t)
1301# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
1302# -o - show only once, i.e when package is installed for the first time
1303#
1304# Tests:
1305# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1306# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1307# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m 1
1308# rpm -E 'date | %banner -e banner' > m; sh -x m
1309# rpm -E 'date | %banner -o -e banner' > m; sh -x m
1310#
1311%banner(aenot:) %{-o:([ "$1" != 1 ] ||} ( \
1312RPM_SCRIPTVERBOSITY=5 \
1313[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1314if [ -x /usr/bin/banner.sh ]; then \
1315 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1316else \
1317 CMD="cat%{-e: >&2}" \
1318fi \
1319eval $CMD %{?2:%2}%{?3: %3})%{-o:)} \
1320%{nil}
1321
1322# useradd/groupadd macros
1323# Author: Elan Ruusamäe <glen@pld-linux.org>
1324#
1325# Usage:
1326# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1327# [-g initial_group] [-G group[,...]] login
1328#
1329# -u uid. REQUIRED
1330# -g gid/group. REQUIRED
1331# -s defaults to /bin/false
1332# -d defaults to /usr/share/empty
1333# -c No default
1334# -r is accepted but ignored (it's always set)
1335# -k skeleton dir. defaults to /usr/share/empty
1336# rpm specific flags
1337# -P package name. defaults to %{name}
1338#
1339%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
1340%{!-u:%{error:useradd: Required argument -u missing}} \
1341%{!-g:%{error:useradd: Required argument -g missing}} \
1342%{!?1:%{error:useradd: Required parameter login missing}} \
1343if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1344 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1345 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1346 exit 1 \
1347 fi \
1348else \
1349 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1350 /usr/sbin/useradd \\\
1351 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
1352 -u %{-u*} \\\
1353 -r \\\
1354 -d %{-d*}%{!-d:/usr/share/empty} \\\
1355 -s %{-s*}%{!-s:/bin/false} \\\
1356 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
1357 -g %{-g*} \\\
1358 %{-M} \\\
1359 %{-G:-G %{-G*}} \\\
1360 %{expand:%{%{#}}} 1>&2 || exit $? \
1361 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
1362fi;
1363# vim: "
1364
1365# Usage:
1366# %groupadd [-P package] [-g gid] group
1367#
1368# -g gid. REQUIRED
1369#
1370# Sample:
1371# %groupadd -P %{name}-base -g %{gid} %{name}
1372
1373%groupadd(g:P:rfo) \
1374%{!-g:%{error:groupadd: Required argument -g missing}} \
1375%{!?1:%{error:groupadd: Required parameter group missing}} \
1376if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1377 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1378 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1379 exit 1 \
1380 fi \
1381else \
1382 echo "Adding group %{1} GID=%{-g*}." \
1383 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1384 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1385fi;
1386
1387# webapp macros
1388# Author: Elan Ruusamäe <glen@pld-linux.org>
1389#
1390# The config is installed/removed inside trigger, this means that you can any
1391# time install apache1/apache/lighttpd package and the configuration file is
1392# updated. if you don't need the config for various reason for specific
1393# webserver, just remove the symlink from config directory using webapp
1394# program. the trigger will not recreate the symlink on upgrades. In other
1395# words the config is linked to webserver config directory on first install of
1396# PACKAGE or WEBSERVER.
1397#
1398# Add package's webserver config to webserver webapps dir.
1399# Usage:
1400# %webapp_register [-f] WEBSERVER WEBAPP
1401#
1402%webapp_register(f) \
1403%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1404if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1405 /usr/sbin/webapp register %1 %2\
1406fi\
1407# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
1408if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
1409 %{expand:%service -q %%1 reload}\
1410fi\
1411%{nil}
1412
1413# Remove package's config from webserver webapps dir.
1414# Usage:
1415# %webapp_register [-f] WEBSERVER WEBAPP
1416%webapp_unregister(f) \
1417%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1418# remove link if either of the packages are gone \
1419if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
1420 /usr/sbin/webapp unregister %1 %2\
1421 %{expand:%service -q %%1 reload}\
1422fi \
1423%{nil}
1424
1425# service macro.
1426# Author: Elan Ruusamäe <glen@pld-linux.org>
1427#
1428# calls usual service restart on package %post, but skips the restart if
1429# administrator has disabled automatic service restarts in either global
1430# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1431#
1432# Usage:
1433# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1434#
1435# -q be silent when service isn't started (for scriplets restaring other package's services)
1436# -n NOOP mode, do not actually restart service
1437#
1438# Requirements:
1439# BuildRequires: rpmbuild(macros) >= 1.268
1440# Requires: rc-scripts
1441# -n option:
1442# BuildRequires: rpmbuild(macros) >= 1.450
1443%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1} RPM_BUILD_ROOT=%{buildroot}; /usr/lib/rpm/service_generator.sh %{*}) };}
1444
1445# Java macros. based on jpackage macros.java
1446#
1447# Root directory where all Java VMs/SDK/JREs are installed.
1448%_jvmdir %{_libdir}/jvm
1449
1450# Root directory where all Java VMs/SDK/JREs expose their jars
1451%_jvmjardir %{_libdir}/jvm-exports
1452
1453# Root directory for all Java VM/SDK/JRE's private things.
1454%_jvmprivdir %{_libdir}/jvm-private
1455
1456# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1457%_jvmlibdir %{_libdir}/jvm
1458
1459# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1460%_jvmdatadir %{_datadir}/jvm
1461
1462# Root directory for all configurations parts of Java VM/SDK/JRE's
1463%_jvmsysconfdir %{_sysconfdir}/jvm
1464
1465# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1466%_jvmcommonlibdir %{_libdir}/jvm-common
1467
1468# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1469%_jvmcommondatadir %{_datadir}/jvm-common
1470
1471# Root directory for all common configurations parts of Java VM/SDK/JRE's
1472%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
1473
1474# Directory where arch-specific (JNI) version-independent jars are installed.
1475%_jnidir %{_libdir}/java
1476
1477
1478# JDK selection. Set this to name of the JDK implementation to use
1479# insead of the system default
1480#%use_jdk icedtea6
1481
1482# expands to the value with right jdk for BuildRequires header
1483# 'jdk' if %%use_jdk is not defined, jdk(%%use_jdk) otherwise
1484# The requirement will not replace current 'default' JDK
1485%required_jdk jdk%{?use_jdk:(%{use_jdk})}
1486
1487%buildrequires_jdk BuildRequires: %required_jdk
1488
1489%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm}%{?use_jdk:JAVA_HOME=%{_jvmdir}/%{use_jdk}}; echo ${JAVA_HOME:-ERROR})}%java_home
1490
1491%_javasrcdir %{_usrsrc}/java
1492
1493%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
1494%jar %{java_home}/bin/jar
1495%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd}%{?use_jdk:JAVACMD=%{java_home}/bin/java}; echo $JAVACMD)}%java
1496%javac %{java_home}/bin/javac
1497%javadoc %{java_home}/bin/javadoc
1498
1499%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
1500
1501%jpackage_script() \
1502install -d $RPM_BUILD_ROOT%{_bindir}\
1503cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1504#!/bin/sh\
1505#\
1506# %{name} script\
1507# JPackage Project <http://www.jpackage.org/>\
1508\
1509# Source functions library\
1510. %{_javadir}-utils/java-functions\
1511\
1512# Source system prefs\
1513if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1514 . %{_sysconfdir}/java/%{name}.conf\
1515fi\
1516\
1517# Source user prefs\
1518if [ -f $HOME/.%{name}rc ]; then\
1519 . $HOME/.%{name}rc\
1520fi\
1521\
1522# Configuration\
1523MAIN_CLASS=%1\
1524BASE_FLAGS=%2\
1525BASE_OPTIONS=%3\
1526BASE_JARS="%(echo %4 | tr ':' ' ')"\
1527\
1528# Set parameters\
1529set_jvm\
1530set_classpath $BASE_JARS\
1531set_flags $BASE_FLAGS\
1532set_options $BASE_OPTIONS\
1533\
1534# Let's start\
1535run "$@"\
1536EOF
1537
1538# jpackage 1.7
1539# Directory for maven depmaps
1540#
1541%_mavendepmapdir /etc/maven
1542%_mavendepmapfragdir /etc/maven/fragments
1543
1544#
1545# add_to_depmap adds an entry to the depmap. The arguments are:
1546#
1547# %1 the original groupid
1548# %2 the original artifact id
1549# %3 the version
1550# %4 the new groupid
1551# %5 the new artifactid
1552#
1553
1554%add_to_maven_depmap() \
1555install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1556cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1557<dependency>\
1558 <maven>\
1559 <groupId>%1</groupId>\
1560 <artifactId>%2</artifactId>\
1561 <version>%3</version>\
1562 </maven>\
1563 <jpp>\
1564 <groupId>%4</groupId>\
1565 <artifactId>%5</artifactId>\
1566 <version>%3</version>\
1567 </jpp>\
1568</dependency>\
1569\
1570EOF\
1571%{nil}
1572
1573#==============================================================================
1574#
1575# update_maven_depmap updates the main maven depmap
1576#
1577%update_maven_depmap() \
1578echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1579if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1580cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1581fi\
1582echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1583
1584# JAVA macros specific for PLD
1585
1586# Directory for tomcat context configuration files
1587%_tomcatconfdir /etc/tomcat/Catalina/localhost
1588
1589# Tomcat cache path
1590%_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1591
1592# Clear tomcat cache
1593# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1594#
1595# Usage:
1596# %%tomcat_clear_cache appname
1597#
1598# Call this script in %postun scriptlet. It will remove compiled jsps related to
1599# given app.
1600#
1601%tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1602
1603# PEAR install macros
1604# Author: Elan Ruusamäe <glen@pld-linux.org>
1605#
1606# Usage:
1607# %%pear_package_setup ...
1608#
1609# -a # - also unpack SOURCE#. for PEAR bootstrapping
1610# -n FMT - create builddir with FMT, instead of default %%{pearname}-%%{version}
1611# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1612# -D - pass -D to %setup (so the build dir is not removed)
1613# -c - register channel from local channel.xml file
1614# -d - pass -d arg to pearcmd
1615#
1616# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1617# destination hierarchy. you should copy the tree to buildroot after
1618# patching/reorganizing with %%pear_package_install.
1619#
1620# additionally BUILDROOT is stripped from files and files are converted to UNIX
1621# line endings.
1622#
1623# the pear install process output is recorded to install.log, you should put it
1624# to %%doc for later debug or just for information.
1625#
1626# additionally additional-packages.txt is produced if it was detected that the
1627# package has optional dependencies. the file format is suitable of displaying
1628# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1629# automatically added for this file.
1630
1631
1632# records install.log and transforms PEAR names to PLD Linux rpm package names.
1633%__pear_install_log \
1634tee install.log \
1635# make post message of optional packages \
1636grep -E 'can optionally use|Optional feature' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,' > optional-packages.txt \
1637if [ -s optional-packages.txt ]; then \
1638 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1639else \
1640 rm -f optional-packages.txt \
1641fi \
1642%{nil}
1643
1644# Command invoking PEAR CLI
1645# Same as /usr/bin/pear, except we force GMT timezone
1646%__pear %__php -doutput_buffering=1 -dopen_basedir="" -dmemory_limit=-1 -ddate.timezone=GMT /usr/share/pear/pearcmd.php
1647
1648%pear_install(a:d:n:zD) \
1649%__pear \\\
1650 -c %{builddir}/pearrc \\\
1651 -d doc_dir=/docs \\\
1652 -d temp_dir=/tmp \\\
1653 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
1654 -d bin_dir=%{_bindir} \\\
1655 -d data_dir=%{php_pear_dir}/data \\\
1656 -d test_dir=%{php_pear_dir}/tests \\\
1657 %{-d:%(echo "%{-d*}" | awk 'BEGIN{RS=","}{printf("-d %%s \\\\\\n\\t", $1)}')} \\\
1658 install \\\
1659 --packagingroot=%{builddir} \\\
1660 --offline \\\
1661 --nodeps \\\
1662 %{-f:--force} \\\
1663 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1664 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
1665%{nil}
1666
1667# The main macro.
1668# using this macro will append optional-packages.txt to the nocompressdoc list
1669# as it's displayed to user after package install. and adding additional gzip
1670# dep is just waste ;)
1671%pear_package_setup(a:d:n:zDc:) \
1672%define srcdir %{-n*}%{!-n:%{?_pearname}%{!?_pearname:%{pearname}}-%{version}} \
1673%define builddir %{_builddir}/%{srcdir} \
1674%setup -q -c -T %{-D:-D} -n %{srcdir} \
1675%{-z:%{__tar} zxf %{S:0}; %{-a:%{__tar} zxf %{S:%{-a*}}}} \
1676%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1677%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
1678%pear_install \
1679%{-z:cd ..} \
1680%{__tar} --wildcards -zvxf %{S:0} package*.xml \
1681cat %{-z:$_N/}.install.log | %__pear_install_log \
1682%undos -f php,html,js,xml \
1683%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1684%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1685%{nil}
1686
1687# Copies extracted PEAR package structure and PEAR registry to buildroot.
1688# Author: Elan Ruusamäe <glen@pld-linux.org>
1689%pear_package_install() \
1690cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1691# tests should not be packaged \
1692%{__rm} -rf $RPM_BUILD_ROOT%{php_pear_dir}/tests \
1693# cleanup backups \
1694find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1695# help the developer out a little: \
1696if [ -f _noautoreq ]; then \
1697 echo "AutoReqdep detected:" \
1698 echo "_noautoreq $(cat _noautoreq)" \
1699fi \
1700%{nil}
1701
1702# Print optional package info for pear packages
1703# Author: Elan Ruusamäe <glen@pld-linux.org>
1704# Usage:
1705# %post -p <lua>
1706# %%pear_package_print_optionalpackages
1707#
1708# Requirements:
1709# BuildRequires: rpmbuild(macros) >= 1.571
1710%pear_package_print_optionalpackages \
1711f = io.open("%{_docdir}/%{name}-%{version}/optional-packages.txt", "r") \
1712if f then \
1713 for l in f:lines() do print(l); end \
1714 f:close() \
1715end \
1716%{nil}
1717
1718
1719# Register OpenLDAP schema.
1720# Author: Elan Ruusamäe <glen@pld-linux.org>
1721#
1722# Usage:
1723# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1724#
1725# -d specify dependant schemas, separated by comma
1726#
1727%openldap_schema_register(d:) \
1728for schema in %*; do \
1729 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1730 %{__sed} -i -e " \
1731 /^include.*local.schema/{ \
1732 iinclude\\t $schema\
1733 } \
1734 " /etc/openldap/slapd.conf \
1735 fi \
1736done \
1737# enable dependant schemas \
1738if [ "%{-d*}" ]; then \
1739 %{__sed} -i -e ' \
1740 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1741 s/^#// \
1742 }' /etc/openldap/slapd.conf \
1743fi \
1744%{nil}
1745
1746# Unregister OpenLDAP schema.
1747# Author: Elan Ruusamäe <glen@pld-linux.org>
1748#
1749# Usage:
1750# %%openldap_schema_unregister %{schemadir}/horde.schema
1751#
1752%openldap_schema_unregister() \
1753for schema in %*; do \
1754 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1755 %{__sed} -i -e " \
1756 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1757 # for symmetry it would be nice if we disable enabled schemas in post, \
1758 # but we really can not do that, it would break something else. \
1759 " /etc/openldap/slapd.conf \
1760 fi \
1761done \
1762%{nil}
1763
1764%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1765
1766# patchset macros
1767# generate SourceX urls from range START STOP
1768# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1769# The sources start from 10000
1770#
1771# Author: Elan Ruusamäe <glen@pld-linux.org>
1772#
1773# Usage:
1774# %patchset_source -f <seq(1) format> <start> [<end>]
1775# %patchset_patch <start> [<end>]
1776# If <end> is omited, it is assumed to be <start>.
1777#
1778# For example in preamble:
1779# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1780# and in %prep:
1781# %patchset_patch 33 44
1782#
1783# Using sources list:
1784# BuildRequires: rpmbuild(macros) >= 1.426
1785# %patchset_source -f <url> -s <filelist>
1786# %patchset_patch -s <filelist>
1787# For example (ncurses):
1788# BuildRequires: rpmbuild(macros) >= 1.683
1789# %patchset_source -f ftp://dickey.his.com/ncurses/%{basever}/ -s sources
1790# %patchset_patch -s sources -p1
1791#
1792
1793%patchset_source(f:b:s:) %(
1794 base=%{-b*}%{!-b*:10000}
1795%{-s:
1796 baseurl='%{-f*}'
1797 filelist='%{-s*}'
1798 i=$base
1799 while read checksum file; do
1800 printf "Patch%d: %s%s\\n" $i "$baseurl" "$file"
1801 i=$((i+1))
1802 done < $filelist
1803}
1804%{!-s:
1805 start=$(expr $base + %1);
1806 end=$(expr $base + %{?2}%{!?2:%{1}});
1807 # we need to call seq twice as it doesn't allow two formats
1808 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1809 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1810 paste %{tmpdir}/__ps{1,2};
1811 rm -f %{tmpdir}/__ps{1,2};
1812}
1813) \
1814%{nil}
1815
1816# apply sources from %patchset_source
1817# -p specify -pX for %patch line
1818# -b base offset: defaults to 10000
1819# -s filelist to read files from
1820%patchset_patch(f:p:b:s:) %(
1821 base=%{-b*}%{!-b*:10000}
1822 patchlevel=%{-p*:-p%{-p*}}
1823%{-s:
1824 filelist='%{-s*}'
1825 i=$base
1826 while read checksum file; do
1827 printf "patch%d %s\\n" $i "$patchlevel" | sed -e s,^,%%,
1828 i=$((i+1))
1829 done < $filelist
1830}
1831%{!-s:
1832 start=$(expr $base + %1);
1833 end=$(expr $base + %{?2}%{!?2:%{1}});
1834 echo ": patchset_patch %1%{?2: to %2}";
1835 seq -f "patch%g $patchlevel" $start $end | sed -e s,^,%%,;
1836}
1837) \
1838%{nil}
1839
1840# return EXPANDED source url N from current spec
1841%sourceurl(n:) %(test "$IN_RPM" = 1 && exit 1; export IN_RPM=1; rpmbuild --nodigest --nosignature --nobuild -D "prep %%dump" %{_specdir}/%{name}.spec 2>&1 | awk '$2 ~ /^SOURCEURL%{-n*}/ {print $3}')
1842
1843# browser plugins v2
1844# Author: Elan Ruusamäe <glen@pld-linux.org>
1845#
1846# Usage:
1847# %browser_plugins_add_browser <name> -p <plugindir>
1848#
1849# <name> (required) -- name of the browser. usually %{name}.
1850# -p <plugindir> (required) -- in what directory browser searches for its plugins.
1851# -b -- default blacklists
1852# -a <arch> override arch
1853#
1854# Example:
1855# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1856
1857%_browserpluginsconfdir /etc/browser-plugins
1858%_browserpluginsdir %{_libdir}/browser-plugins
1859%update_browser_plugins /usr/sbin/update-browser-plugins || :
1860
1861%browser_plugins_add_browser(p:b:a:) \
1862 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1863 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1864 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1865 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1866 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1867 %{-b:cat >> $blacklist_file %{-b*}} \
1868%{nil}
1869
1870# Helper for LUA.
1871# split string separated by space into quoted list
1872#
1873# Author: Elan Ruusamäe <glen@pld-linux.org>
1874#
1875# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1876%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1877
1878# adjust /etc/shells by adding and removing shells from there
1879# Author: Elan Ruusamäe <glen@pld-linux.org>
1880#
1881# Usage:
1882# %post -p <lua>
1883# %lua_add_etc_shells /bin/sh /bin/pdksh
1884#
1885# %preun -p <lua>
1886# if arg[2] == 0 then
1887# %lua_remove_etc_shells /bin/bash /bin/rbash
1888# end
1889#
1890# Requirements:
1891# BuildRequires: rpmbuild(macros) >= 1.462
1892#
1893
1894%lua_add_etc_shells() \
1895t = {}\
1896f = io.open("/etc/shells", "r")\
1897if f then\
1898 for l in f:lines() do t[l]=l; end\
1899 f:close()\
1900end\
1901for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1902 if not t[s] then\
1903 print("Adding "..s.." to /etc/shells")\
1904 f = io.open("/etc/shells", "a")\
1905 if f then\
1906 f:write(s.."\\n")\
1907 f:close()\
1908 end\
1909 end\
1910end\
1911%{nil}
1912
1913%lua_remove_etc_shells() \
1914t = {}\
1915f = io.open("/etc/shells", "r")\
1916if f then\
1917 for l in f:lines() do t[l]=l; end\
1918 f:close()\
1919end\
1920for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1921 print("Removing "..l.." from /etc/shells")\
1922 t[l] = nil\
1923end\
1924s=""\
1925for _, l in pairs(t) do\
1926 s=s..l.."\\n"\
1927end\
1928f = io.open("/etc/shells", "w")\
1929if f then\
1930 f:write(s)\
1931 f:close()\
1932end\
1933%{nil}
1934
1935# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1936#
1937# Author: Elan Ruusamäe <glen@pld-linux.org>
1938#
1939# Usage:
1940# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1941# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1942#
1943# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1944#
1945# Requirements:
1946# BuildRequires: rpmbuild(macros) >= 1.429
1947#
1948%add_etc_shells(p) %{-p:<lua>}\
1949%{expand:%%lua_add_etc_shells %*}\
1950%{nil}
1951
1952%remove_etc_shells(p) %{-p:<lua>}\
1953%{-p:if arg[2] == 0 then}\
1954%{expand:%%lua_remove_etc_shells %*}\
1955%{-p:end} \
1956%{nil}
1957
1958# Check syntax for Python files
1959#
1960# Author: Elan Ruusamäe <glen@pld-linux.org>
1961# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1962#
1963# Usage:
1964# %py_lint src
1965#
1966# Requirements:
1967# BuildRequires: python
1968# BuildRequires: rpmbuild(macros) >= 1.602
1969
1970%py_lint() \
1971__py_lint() { \
1972%{!?debug:set +x;} \
1973find "$@" -type f -name '*.py' | python -c ' \
1974import sys \
1975import compiler \
1976\
1977found = err = 0\
1978for f in sys.stdin: \
1979 fd = open(f.rstrip()) \
1980 c = fd.read() \
1981 fd.close() \
1982 found = found + 1 \
1983 try: \
1984 compiler.parse(c) \
1985 except SyntaxError, e: \
1986 print "py_lint: %s: %s" % (f.rstrip(), e) \
1987 err = err + 1\
1988\
1989if not found:\
1990 print >> sys.stderr, "\\npy_lint: ERROR: No files processed.\\n" \
1991 sys.exit(1) \
1992elif err: \
1993 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1994 sys.exit(1) \
1995else: \
1996 print >> sys.stderr, "py_lint: %d files scanned, found no syntax errors." % found \
1997' \
1998}; __py_lint %* \
1999%{nil}
2000
2001# Undos files
2002#
2003# Author: Paweł Zuzelski <pawelz@pld-linux.org>
2004# Author: Elan Ruusamäe <glen@pld-linux.org>
2005#
2006# Usage:
2007# %undos list_of_files
2008# %undos -f EXT[,EXT]
2009# %undos -i -f EXT[,EXT]
2010#
2011# -f EXT[,EXT] - find(1) files by extensions
2012# -i - case insensitive file search
2013#
2014# Example:
2015# Un-DOS all *.js, *.css files
2016# %undos -f js,css
2017# Un-DOS all *.js, *.JS files
2018# %undos -f js -i
2019# undos all Makefiles
2020# %{__find} -name Makefile | xargs %undos
2021#
2022# Requirements:
2023# BuildRequires: sed >= 4.0
2024# BuildRequires: rpmbuild(macros) >= 1.674
2025
2026# NB: make sure this macro stays on one line
2027# NB: make sure it includes newline escape
2028%undos(f:i) %{-f:%{__find} -type f -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
2029%{nil}
2030
2031# Hook to register nagios object based plugins in Nagios NRPE daemon config.
2032#
2033# Author: Elan Ruusamäe <glen@pld-linux.org>
2034#
2035# Usage:
2036# -a NAME -- add command named NAME
2037# -d NAME -- remove command named NAME
2038# -f FILE -- specify plugin configuration FILE to extract command definition from
2039#
2040# Sample:
2041# %triggerin -- nagios-nrpe
2042# %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
2043#
2044# %triggerun -- nagios-nrpe
2045# %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
2046#
2047# Requirements:
2048# Requires: grep
2049# Requires: sed >= 4.0
2050# BuildRequires: rpmbuild(macros) >= 1.685
2051%nagios_nrpe(a:d:c:f:) {\
2052 if %{__grep} -q '^include_dir=/etc/nagios/nrpe.d' /etc/nagios/nrpe.cfg && [ -d /etc/nagios/nrpe.d ]; then \
2053 file=/etc/nagios/nrpe.d/%{-a*}%{-d*}.cfg; \
2054 else \
2055 file=/etc/nagios/nrpe.cfg; \
2056 fi; \
2057 m=$(test -f $file && md5sum < $file); \
2058 %{-a:# on -a and config exists \
2059 if [ -f /etc/nagios/nrpe.cfg ]; then \
2060 if [ ! -f $file ] || ! %{__grep} -q '^command\[%{-a*}\]' $file; then \
2061 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> $file; \
2062 fi; \
2063 fi;} \
2064 %{-d:# on package remove, -d and config exists \
2065 if [ "$1" = "0" -a -f $file ]; then \
2066 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' $file; \
2067 fi;} \
2068 if [ "$m" != "$(md5sum < $file)" ]; then \
2069 %service -q nrpe restart; \
2070 fi; \
2071}%{nil}
2072
2073# Import or update Cacti template.
2074#
2075# Author: Elan Ruusamäe <glen@pld-linux.org>
2076#
2077# Usage:
2078# %cacti_import_template XMLFILE
2079# XMLFILE -- XML template to import
2080#
2081# Sample:
2082# %post
2083# %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
2084#
2085# Requires: cacti >= 0.8.7e-8
2086# BuildRequires: rpmbuild(macros) >= 1.630
2087# Note: 1.1 (cacti-0.8.7h) adds requirement for --with-template-rras or --with-user-rras option
2088
2089%cacti_import_template() {\
2090v=$(%{__sed} -rne 's/.+Add Graphs Script ([0-9\.]+).+/\1/p' /usr/share/cacti/cli/import_template.php); \
2091if [ "$v" != "1.0" ]; then \
2092 rra="--with-template-rras"; \
2093fi; \
2094/usr/share/cacti/cli/import_template.php --filename=%1 $rra || :; \
2095}%{nil}
2096
2097# pre/post script for -upstart subpackages
2098#
2099# Author: Jacek Konieczny <jajcus@jajcus.net>
2100# Author: Elan Ruusamäe <glen@pld-linux.org>
2101#
2102# Usage:
2103# %upstart_post service_name
2104# %upstart_postun service_name
2105#
2106# Sample:
2107# %post upstart
2108# %upstart_post %{name}
2109#
2110# %postun upstart
2111# %upstart_postun %{name}
2112#
2113# Requirements:
2114# BuildRequires: rpmbuild(macros) >= 1.690
2115# Requires: rc-scripts >= 0.4.3
2116
2117# migrate from init script to upstart job
2118%upstart_post() \
2119 if [ -x /sbin/initctl ] && [ -f /var/lock/subsys/%1 ]; then \
2120 /sbin/service --no-upstart %1 stop \
2121 /sbin/service %1 start \
2122 fi \
2123%{nil}
2124
2125# restart the job after upgrade or migrate to init script on removal
2126# cannot be stopped with 'service' as /etc/init/$name.conf may be missing
2127# at this point
2128%upstart_postun() \
2129 if [ -x /sbin/initctl ] && /sbin/initctl status %1 2>/dev/null | grep -q 'running' ; then \
2130 /sbin/initctl stop %1 >/dev/null 2>&1 \
2131 [ -f /etc/rc.d/init.d/%1 -o -f /etc/init/%1.conf ] && { echo -n "Re-"; /sbin/service %1 start; }; \
2132 fi \
2133%{nil}
2134
2135# Haskell Macros
2136# BuildRequires: rpmbuild(macros) >= 1.608
2137%ghcdir ghc-%(/usr/bin/ghc --numeric-version 2>/dev/null || echo ERROR)
2138
2139# update /usr/lib*/ghc-*/package.conf.d/package.cache
2140# Requires: ghc
2141# BuildRequires: rpmbuild(macros) >= 1.607
2142#
2143%ghc_pkg_recache() {{ \
2144 umask 022; \
2145 [ ! -x /usr/bin/ghc-pkg ] || /usr/bin/ghc-pkg recache; \
2146};} \
2147%{nil}
2148
2149
2150# pre/post script for packages supporting systemd units
2151#
2152# Authors: Bartlomiej Zimon <uzi18@o2.pl>
2153# Jan Rękorajski <baggins@mimuw.edu.pl>
2154#
2155# Usage:
2156# %systemd_reload
2157# %systemd_service <unit command> service_name1.service service_name2.service
2158# %systemd_service_enable service_name1.service service_name2.service
2159# %systemd_service_disable service_name1.service service_name2.service
2160# %systemd_service_start service_name1.service service_name2.service
2161# %systemd_service_stop service_name1.service service_name2.service
2162# %systemd_service_restart service_name1.service service_name2.service
2163# %systemd_service_reload service_name1.service service_name2.service
2164#
2165# %systemd_post service_name1.service service_name2.service
2166# %systemd_preun service_name1.service service_name2.service
2167# %systemd_trigger service_name1.service service_name2.service
2168#
2169# Sample:
2170# %post
2171# %systemd_post %{name}.service
2172#
2173# %preun
2174# %systemd_preun %{name}.service
2175#
2176# %postun
2177# %systemd_reload
2178#
2179# %triggerpostun -- %{name} < first-version-with-systemd-units
2180# %systemd_trigger %{name}.service
2181#
2182# Requirements:
2183# BuildRequires: rpmbuild(macros) >= 1.671
2184# Requires: systemd-units >= 38
2185
2186%systemd_reload /bin/systemd_booted && SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog /bin/systemctl --quiet daemon-reload || :
2187
2188%systemd_service_enable() \
2189 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2190 /bin/systemctl preset --preset-mode=enable-only %{*} || : \
2191 /bin/systemd_booted && echo 'Run "/bin/systemctl start %{*}" to start %{*}.' || : \
2192%{nil}
2193
2194%systemd_service_disable() \
2195 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2196 /bin/systemctl --quiet disable %{*} || : \
2197%{nil}
2198
2199%systemd_service() \
2200 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2201 /bin/systemd_booted && /bin/systemctl --quiet %{*} || : \
2202%{nil}
2203
2204%systemd_service_start() \
2205 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2206 /bin/systemd_booted && /bin/systemctl --quiet start %{*} || : \
2207%{nil}
2208
2209%systemd_service_stop() \
2210 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2211 /bin/systemd_booted && /bin/systemctl --quiet stop %{*} || : \
2212%{nil}
2213
2214# doesn't honour RPM_SKIP_AUTO_RESTART, avoid using
2215%systemd_service_restart() \
2216 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2217 /bin/systemd_booted && /bin/systemctl --quiet try-restart %{*} || : \
2218%{nil}
2219
2220# doesn't honour RPM_SKIP_AUTO_RESTART, avoid using
2221%systemd_service_reload() \
2222 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2223 /bin/systemd_booted && /bin/systemctl --quiet reload %{*} || : \
2224%{nil}
2225
2226# NOTE: this trigger disobeys systemd.preset in favour of RPM_ENABLE_SYSTEMD_SERVICE
2227%systemd_trigger() \
2228want_enable_service() { \
2229 [ -f /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
2230 [ ${RPM_ENABLE_SYSTEMD_SERVICE:-yes} = no ] && return 1 \
2231 [ "$(echo /etc/rc.d/rc[0-6].d/S[0-9][0-9]${1%.service})" = "/etc/rc.d/rc[0-6].d/S[0-9][0-9]${1%.service}" ] && return 1 \
2232 return 0 \
2233}\
2234 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2235 for s in %{*}; do \
2236 if want_enable_service $s; then \
2237 /bin/systemctl --quiet enable $s || : \
2238 fi \
2239 done \
2240%{nil}
2241
2242# TODO: resurrect RPM_SKIP_AUTO_RESTART by using $(skip_auto_restart) function defined by %service from service_generator.sh
2243%systemd_post() \
2244 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2245 /bin/systemd_booted && /bin/systemctl --quiet daemon-reload || : \
2246 if [ $1 -eq 1 ]; then \
2247 /bin/systemctl preset --preset-mode=enable-only %{*} || >/dev/null : \
2248 /bin/systemd_booted && echo 'Run "/bin/systemctl start %{*}" to start %{*}.' || : \
2249 elif [ -z "$NORESTART" ]; then \
2250 /bin/systemd_booted && /bin/systemctl --quiet try-restart %{*} || : \
2251 else \
2252 /bin/systemd_booted && echo 'Run "/bin/systemctl restart %{*}" to restart %{*}.' || : \
2253 fi \
2254%{nil}
2255
2256%systemd_preun() \
2257 if [ $1 -eq 0 ]; then \
2258 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2259 /bin/systemd_booted && /bin/systemctl --quiet stop %{*} || : \
2260 /bin/systemctl --quiet disable %{*} || : \
2261 fi \
2262%{nil}
2263
2264%systemdunitdir /lib/systemd/system
2265%systemduserunitdir /usr/lib/systemd/user
2266%systemdtmpfilesdir /usr/lib/tmpfiles.d
2267
2268#-----------------------------------------------------------------
2269# Update hardware database index
2270#
2271# Requirements:
2272# BuildRequires: rpmbuild(macros) >= 1.691
2273# Requires: udev-core >= 1:196
2274
2275%udev_hwdb_update() \
2276/sbin/udevadm hwdb --update >/dev/null 2>&1 || : \
2277%{nil}
2278
2279# Generate vim help tags file
2280#
2281# Requirements:
2282# BuildRequires: rpmbuild(macros) >= 1.718
2283# Requires(post,postun): /usr/bin/vim
2284# Requires(post,postun): vim-rt >= 4:7.4.2054-2
2285%vim_doc_helptags() \
2286umask 022; \
2287/usr/bin/vim -c ':helptags /usr/share/vim/doc' -c ':q' 2>/dev/null \
2288%{nil}
2289
2290# EOF
This page took 0.138764 seconds and 4 git commands to generate.